/*
 * Copyright (c) 2009, Takeyuki Nagao
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or
 * without modification, are permitted provided that the
 * following conditions are met:
 * 
 *  * Redistributions of source code must retain the above
 *    copyright notice, this list of conditions and the
 *    following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the
 *    following disclaimer in the documentation and/or other
 *    materials provided with the distribution.
 *    
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
 * CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
 * OF SUCH DAMAGE.
 */

package dvi.v2.cache;

import java.util.Map;
import java.util.logging.Logger;

public abstract class AbstractCacheCostHandler<K, V>
implements CacheCostHandler<K, V>
{
  private static final Logger LOGGER = Logger.getLogger(AbstractCacheCostHandler.class
      .getName());

  private long currentSize;
  private long maxSize;
  
  public AbstractCacheCostHandler(long maxSize)
  {
    this.setMaxSize(maxSize);
  }
  
  public synchronized void modifyCostsOnAppend(Map<K, V> map, K key, V value) {
    long s = computeItemSize(key, value);
    currentSize += s;
    LOGGER.finer(map.hashCode() + ": currentSize=" + currentSize + "(delta=" + s + ") maxSize=" + maxSize);
  }
  
  protected abstract long computeItemSize(K key, V value);

  public synchronized void modifyCostsOnRemove(Map<K, V> map, K key, V value) {
    long s = computeItemSize(key, value);
    currentSize -= s;
    LOGGER.finer(map.hashCode() + ": currentSize=" + currentSize + "(delta=" + (-s) + ") maxSize=" + maxSize);
  }

  public synchronized boolean wantPurge(Map<K, V> map, K key, V value) {
    return (getCurrentSize() > maxSize);
  }

  public void setMaxSize(long maxSize) {
    this.maxSize = Math.max(0, maxSize);
  }

  public long getMaxSize() {
    return maxSize;
  }

  public synchronized long getCurrentSize() {
    return currentSize;
  }

}
